//genesis

float MAINVOL = 1e-18 // m^3
float 	BULKVOL = 1e-15 // m^3
float DIFFCONST = 1e-15 // m^2/sec
int	INTEG = 0		// deterministic

include nonscaf_syn1e.g nox // same as 1g.g but only plots MAPK*

// This little hack is so that the hardcoded handling of the diffusion
// step can recognize the pool, whose name was changed in more recent versions
move /kinetics/MAPK/Raf-GTP-Ras* /kinetics/MAPK/Raf*-GTP-Ras

setfield /editcontrol/vol value {DEFAULT_VOL}

setfield /kinetics/Ca_input CoInit 0.08 slave_enable 4
setfield /kinetics/Ca CoInit 0.08 slave_enable 0
setfield /kinetics/Glu CoInit 0.0 slave_enable 4
setfield /kinetics/EGFR/EGF CoInit 0.0 slave_enable 4

rescale_vol {MAINVOL}

setfield /kinetics/MKP-1 CoInit 0.0024

float BASALDT = 20e-6
float FINEDT = 1e-6

if (INTEG == 0)
	BASALDT = 200e-6
	FINEDT = 20e-6
end

float XA = {pow {MAINVOL} 0.66666667}
float LEN = {pow {MAINVOL} 0.33333333}
float fastclock = FINEDT
float normclock = BASALDT
float plotclock = 1
float fastequil = 2
float equiltime = 3000
float tet_time = 100
float CA_STIM = 25
float CA_BASAL = 0.08
float tet_glu_ampl = 1
float post_tet_time = 3600
int save_plot_flag = 1
int PLOT_XDIVS = 200000 // 100 msec accuracy over 5000 sec.
float P2M_equiltime = 2000
float M2P_equiltime = 500

gen_make_1d_diff_pair {BULKVOL} {MAINVOL} {XA} {LEN} {DIFFCONST}

ce /kinetics
clear_non_diffusing_molecules
ce /

str hostname = {getenv HOST}
str fname = "psp_" @ MAINVOL @ "_D_" @ DIFFCONST @ "_" @ INTEG @ "_" @ BULKVOL

function do_phase(duration)
	float duration

	if (INTEG <= 2)
		setclock 0 {fastclock}
		setclock 1 {fastclock}
	end
	if (duration > fastequil)
		step {fastequil} -t
		setclock 0 {normclock}
		setclock 1 {normclock}
		step {duration - fastequil} -t
	else
		step {duration} -t
	end
end

function do_allocate_plot_tabs
	str name
	foreach name ({el /graphs/#/#.Co})
		call {name} TABCREATE {PLOT_XDIVS} 0 1
	end

	foreach name ({el /moregraphs/#/#.Co})
		call {name} TABCREATE {PLOT_XDIVS} 0 1
	end
end

if (DO_X == 0)
	do_allocate_plot_tabs
end

do_set_integ_method {INTEG}
randseed2

setclock 0 {BASALDT}
setclock 1 {BASALDT}
setclock 2 {plotclock}
setclock 3 {plotclock}

float level
echo "/newplot" >> {fname}.psp
echo "/plotname set_MAPK" >> {fname}.psp
reset
foreach level (1e-4 1e-3 2e-3 5e-3 0.01 0.015 0.02 0.025 0.03 0.04 0.05 0.1 0.2 0.5 1)
	setfield /kinetics/MAPK* CoInit {level} slave_enable 4
	do_phase {M2P_equiltime}
	echo {getfield /kinetics/PKC-active Co} {level} >> {fname}.psp
end
setfield /kinetics/MAPK* CoInit 0 slave_enable 2

echo "/newplot" >> {fname}.psp
echo "/plotname set_PKC" >> {fname}.psp
reset
foreach level (0.01 0.09 0.1 0.11 0.12 0.13 0.15 0.18 0.2 0.25 0.3 0.4 0.5 1)
	setfield /kinetics/PKC-active CoInit {level} slave_enable 4
	do_phase {P2M_equiltime}
	echo {level} {getfield /kinetics/MAPK* Co} >> {fname}.psp
end

quit
